Bugzilla will be upgraded to version 5.0 on a still to be determined date in the near future. The original upgrade date has been delayed.
Bug 622272 - Review Request: mysql-connector-c++ - MySQL database connector for C++
Review Request: mysql-connector-c++ - MySQL database connector for C++
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Chen Lei
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-08-08 10:32 EDT by Remi Collet
Modified: 2010-09-15 03:14 EDT (History)
5 users (show)

See Also:
Fixed In Version: mysql-connector-c++-1.1.0-0.2.bzr888.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-09-15 01:54:12 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
supercyper1: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Remi Collet 2010-08-08 10:32:54 EDT
Spec URL: http://remi.fedorapeople.org/mysql-connector-c++.spec
SRPM URL: http://remi.fedorapeople.org/mysql-connector-c++-1.1.0-0.1.bzr888.fc13.src.rpm
Description: 
MySQL Connector/C++ is a MySQL database connector for C++. 

The MySQL Driver for C++ mimics the JDBC 4.0 API. 
However, Connector/C++ does not implement all of the JDBC 4.0 API.

The Connector/C++ preview features the following classes:
* Connection
* DatabaseMetaData
* Driver
* PreparedStatement
* ResultSet
* ResultSetMetaData
* Savepoint
* Statement 


rpmlint output
mysql-connector-c++.src: W: invalid-url Source0: mysql-connector-c++-bzr888.tgz

koji scratch build for rawhide
http://koji.fedoraproject.org/koji/taskinfo?taskID=2388155

Other SPEC URL:
http://github.com/remicollet/remirepo/tree/master/mysql-connector-c%2B%2B/

This is a bazaar snapshot as this exact release is required by MySQL Workbench.
Comment 1 Chen Lei 2010-08-09 01:58:35 EDT
 +:ok, =:needs attention, -:needs fixing ?: unknown

MUST Items:
[+] MUST: rpmlint must be run on every package.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}
[+] MUST: The package must be licensed with a Fedora approved license and meet
the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual
license.
[+] MUST: If (and only if) the source package includes the text of the
license(s) in its own file, then that file, containing the text of the
license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source,
as provided in the spec URL.
md5sum don't match due to timestamps

[+] MUST: The package must successfully compile and build into binary rpms on
at least one supported architecture.
[+] MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires
[+] MUST: The spec file MUST handle locales properly. This is done by using the
%find_lang macro.
[+] MUST: Every binary RPM package which stores shared library files (not just
symlinks) in any of the dynamic linker's default paths, must call ldconfig in
%post and %postun.
[+] MUST: If the package is designed to be relocatable, the packager must state
this fact in the request for review
[+] MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory.
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every %files section must include a
%defattr(...) line.
[+] MUST: Each package must consistently use macros, as described in the macros
section of Packaging Guidelines.
[+] MUST: The package must contain code, or permissible content. This is
described in detail in the code vs. content section of Packaging Guidelines.
[+] MUST: Large documentation files should go in a doc subpackage.
[+] MUST: If a package includes something as %doc, it must not affect the
runtime of the application.
[+] MUST: Header files must be in a -devel package.
[+] MUST: Static libraries must be in a -static package.
[+] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig'
(for directory ownership and usability).
[+] MUST: If a package contains library files with a suffix (e.g.
libfoo.so.1.1), then library files that end in .so (without suffix) must go in
a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release} 
[+] MUST: Packages must NOT contain any .la libtool archives, these should be
removed in the spec.
[+] MUST: Packages containing GUI applications must include a %{name}.desktop
file, and that file must be properly installed with desktop-file-install in the
%install section.
[+] MUST: Packages must not own files or directories already owned by other
packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.

SHOULD Items:
[+] SHOULD: If the source package does not include license text(s) as a
separate file from upstream, the packager SHOULD query upstream to include it.
[+] SHOULD: The description and summary sections in the package spec file
should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
[+] SHOULD: The package should compile and build into binary rpms on all
supported architectures.
[+] SHOULD: The reviewer should test that the package functions as described.
Importing is OK but whether it is functional is hard to test.

[+] SHOULD: If scriptlets are used, those scriptlets must be sane.
[+] SHOULD: Usually, subpackages other than devel should require the base
package using a fully versioned dependency.
[+] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and
this is usually for development purposes, so should be placed in a -devel pkg.
A reasonable exception is that the main pkg itself is a devel tool not
installed in a user runtime, e.g. gcc or gdb.
[+] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the file
instead of the file itself.
[+] SHOULD: Packages should try to preserve timestamps of original installed
files.

Issues:
1. Group for main package should be Group: System Environment/Libraries

2.%{cmake} should be remove to %build section

3.
It'll be better to use %doc examples to replace %doc examples/README examples/CMakeLists.txt examples/*.cpp examples/*.h, keeping examples directory in %doc will be useful.
e.g.
mkdir __dist_code_examples
cp -pr examples __dist_code_examples/examples

%doc __dist_code_examples/examples

See http://fedoraproject.org/wiki/Packaging_tricks#Examples

4.
# less mysql-connector-c++-1.1.0/driver/mysql_metadata.cpp => getDriverMajorVersion / getDriverMinorVersion / getDriverPatchVersion

What does this line mean?
Comment 2 Chen Lei 2010-08-09 02:23:22 EDT
You can also avoid of building examples by passing -DMYSQLCPPCONN_BUILD_EXAMPLES:BOOL=0 to %cmake, then you can simply use %doc examples to include all example files cleanly.
Comment 3 Remi Collet 2010-08-09 11:59:09 EDT
1. http://github.com/remicollet/remirepo/commit/aba1cbb079ca4e09c7b353f0388263a52ecbd604
2. http://github.com/remicollet/remirepo/commit/e3490aaede60fc337cd2ecda319ed7a58a167b29
3. http://github.com/remicollet/remirepo/commit/7dc4d1115d7881ddc52b9d27450b55cc736ccff7

About 3 : I have apply the solution of a cp before build, because, even without building the examples, dir is dirty (various cmake files).

About 4 : this is just a reminder (for packager) to check this 3 functions in the source code to check if the library version have change

Spec: http://remi.fedorapeople.org/mysql-connector-c++.spec
Srpm: http://remi.fedorapeople.org/mysql-connector-c++-1.1.0-0.2.bzr888.remi.src.rpm
Comment 4 Chen Lei 2010-08-09 23:18:03 EDT
OK, this package is approved.

FYI, you can also remove BuildRoot and rm -rf %{buildroot} in %install section for all current fedora release and %clean section in F13 and above.

See http://fedoraproject.org/wiki/PackagingGuidelines#BuildRoot_tag
Comment 5 Remi Collet 2010-08-10 00:53:29 EDT
Thanks for the quick review.

I know about buildroot, but as far as EL-5 exists, as I like to keep the same spec for all branch when possible, I prefer to keep it.
Comment 6 Remi Collet 2010-08-10 00:56:30 EDT
New Package SCM Request
=======================
Package Name: mysql-connector-c++
Short Description: MySQL database connector for C++ 
Owners: remi
Branches: F-13 F-14 EL-5 EL-6
InitialCC:
Comment 7 Chen Lei 2010-08-10 03:32:00 EDT
(In reply to comment #5)
> Thanks for the quick review.
> 
> I know about buildroot, but as far as EL-5 exists, as I like to keep the same
> spec for all branch when possible, I prefer to keep it.    

Can mysql-connect-c++ work on EL5? As of MySQL Connector/C++ version 1.1.0 it is necessary to have the Boost C++ libraries 1.34.0 or newer installed.
Comment 8 Remi Collet 2010-08-10 03:39:41 EDT
Arg, you're right (I should have check before)...
boost-1.41 is in RHEL-6beta2

New Package SCM Request
=======================
Package Name: mysql-connector-c++
Short Description: MySQL database connector for C++ 
Owners: remi
Branches: F-13 F-14 EL-6
InitialCC:
Comment 9 Kevin Fenzi 2010-08-10 13:59:33 EDT
Git done (by process-git-requests).
Comment 10 Fedora Update System 2010-09-01 13:38:32 EDT
mysql-connector-c++-1.1.0-0.2.bzr888.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/mysql-connector-c++-1.1.0-0.2.bzr888.fc14
Comment 11 Fedora Update System 2010-09-01 13:45:16 EDT
mysql-connector-c++-1.1.0-0.2.bzr888.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/mysql-connector-c++-1.1.0-0.2.bzr888.fc13
Comment 12 Fedora Update System 2010-09-01 23:32:00 EDT
mysql-connector-c++-1.1.0-0.2.bzr888.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update mysql-connector-c++'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/mysql-connector-c++-1.1.0-0.2.bzr888.fc14
Comment 13 Fedora Update System 2010-09-15 01:54:07 EDT
mysql-connector-c++-1.1.0-0.2.bzr888.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 14 Fedora Update System 2010-09-15 03:14:34 EDT
mysql-connector-c++-1.1.0-0.2.bzr888.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.